#include <stdio.h>
#include <math.h>
#include "edges.h"
#include "pgm.h"
#include "globals.h"

double norm[18]={1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};

  int Num_Orientations = 4;
  int Threshold = 0;

/*
main(int argc, char* argv[])
{
  int width, height, max;
  int i, j;
  int size;

  unsigned char **edge_map1, **edge_map2;
  unsigned char *image;
  char base[20], fname[35];

  edge_map1 = (unsigned char **)
			calloc(Num_Orientations, sizeof(unsigned char *));
  edge_map2 = (unsigned char **)
			calloc(Num_Orientations, sizeof(unsigned char *));

  max=read_pgm(argv[1], &image, &width, &height);
  size=width*height;
  write_pgm("temp.pgm", image, width, height, max);

  Edges(width, height, size, edge_map1, image);

  strncpy(base, argv[1], strlen(argv[1])-3);
  base[strlen(argv[1])-3]=0;
  sprintf(fname, "%se000.pgm", base);
  write_pgm(fname, edge_map1[0], width, height, max);
  sprintf(fname, "%se045.pgm", base);
  write_pgm(fname, edge_map1[1], width, height, max);
  sprintf(fname, "%se090.pgm", base);
  write_pgm(fname, edge_map1[2], width, height, max);
  sprintf(fname, "%se135.pgm", base);
  write_pgm(fname, edge_map1[3], width, height, max);
}
/*
  sprintf(fname, "%se120.pgm", base);
  write_pgm(fname, edge_map1[4], width, height, max);
  sprintf(fname, "%se150.pgm", base);
  write_pgm(fname, edge_map1[5], width, height, max);

}
*/

void Edges(int width, int height, int size, unsigned char **edge_map,
		unsigned char *image)
{
  int i, j, edge;
  int radius=1;
  double *temp_map[Num_Orientations];
  char f_name[20];
  int edges[size];
  double mag[size];
  char base[20], fname[35];
  int max=255;

  for(i=0; i<size; i++)
    edges[i]=-1;

  for (i=0; i<Num_Orientations; i++)
  {
    temp_map[i]=(double *) calloc(size, sizeof(double));
    edge_map[i]=(unsigned char *) calloc(size, 1);
  }

  for (i=radius; i<height-radius; i++)
  {
    for (j=radius; j<width-radius; j++)
    {
      edges[i*width+j]=Sobel(i, j, width, image, mag);
    }
  }

  create_maps(edges, temp_map, size, mag);

  MultipleNormalize(size, edge_map, temp_map);

}

void create_maps(int *edges, double **maps, int size, double *mag)
{
  int focus, i;
  double diff;

  for (focus=0; focus<Num_Orientations; focus++)
    for(i=0; i<size; i++)
    {
      if (edges[i]<0) maps[focus][i]=0;
      else
      {
	diff=fabs(focus*(180/Num_Orientations)-edges[i]);
	if (diff>90.0) diff=180.0-diff;
	maps[focus][i]=(90.0-diff)*mag[i];

	/*
	if (!diff) maps[focus][i]=100*mag[i];
	else
	  maps[focus][i]=(90.0/diff)*mag[i];
        */	
      }
    }
  
}

int Sobel(int i, int j, int width, unsigned char *image, double *mag)
{
  float temp;
  double Sx, Sy, ratio;
  int result;

  static int X[9] = {-1,  0,  1,
		     -2,  0,  2,
		     -1,  0,  1 };

  static int Y[9] = {-1, -2, -1,
		      0,  0,  0,
		      1,  2,  1 };

  Sx=Grad(i, j, width, X, image);
  Sy=Grad(i, j, width, Y, image);
  mag[i*width+j]=sqrt(Sx*Sx+Sy*Sy);

  if (Sy==0.0)
  {
    if (Sx==0.0)  result=-1;
    else result=90;
  }
  else
  {
    ratio=Sx/Sy;
    if ((result=atan(ratio)*180/M_PI) < 0)
      result+=180;
  }

  return result;
}


double Grad(int i, int j, int width, int mask[9], unsigned char *image)
{
  int x, y;
  double total=0.0;
  int temp;

  i--; j--;

  for(y=0; y<3; y++)
    for(x=0; x<3; x++)
    {
      temp = mask[y*3+x] * image[(i+y)*width + (j+x)];
      total+=temp;
    }

  return total;

}



void MultipleNormalize(int size, unsigned char **e_map, double **t_map)
{
  int i;
  double currMax, maxVal = 0.0;
  
  for(i=0; i< Num_Orientations; i++)
  {
    currMax = Maximum(size, t_map[i]);
    if (currMax > maxVal)
       maxVal=currMax;
  }

  for(i=0; i< Num_Orientations; i++)

    Normalize(i, maxVal, size, e_map, t_map);

  return;
}  



void Normalize (int edge, int maxValue, int size, unsigned char **e_map,
		double **temp_map)
{
  int i;
  float multFac;

  multFac=255.0/maxValue;

  for(i=0; i<size; i++)
  {
    e_map[edge][i]=(unsigned char)(temp_map[edge][i]*multFac);
    if (e_map[edge][i]<Threshold) e_map[edge][i]=0;
  }
}



float Maximum(int size, double *temp_map)
{
  int i;
  double max=0;

  for (i=0; i<size; i++)
  {
    if (temp_map[i]>max)
      max=temp_map[i];
  }

  return max;
}

